import torch
import torch.nn as nn

BATCH_SIZE = 4096
HIDDEN_DIM = 4096
SHAPE = (BATCH_SIZE, HIDDEN_DIM)

class MElliott(nn.Module):
    '''
    Formula: f(x) = x / sqrt(1 + x^2)
    '''
    def __init__(self):
        super(MElliott, self).__init__()

    def forward(self, x: torch.Tensor) -> torch.Tensor:
        # PyTorch 原生实现
        return x / torch.sqrt(1.0 + x.pow(2))

class Model(nn.Module):
    def __init__(self):
        super(Model, self).__init__()
        self.act = MElliott()
    
    def forward(self, x):
        return self.act(x)

def get_inputs():
    input_tensor = torch.randn(SHAPE, dtype=torch.float32) * 5.0
    return [input_tensor.contiguous()]

def get_init_inputs():
    return []